From 7dce9474af1b9d3d0e22cb90f2a35f924c8861a7 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Fri, 18 Mar 2016 17:56:28 -0400
Subject: [PATCH 09/15] FIXME: RTL frontend

Individual commit messages were:
FIXME: enough to build an rtl1

FIXME: add TODO.rst

FIXME: call read_md_files from rtl-frontend.c

FIXME: driver support

FIXME: a test file, cleaned to just one function, and without log spew

FIXME: enough hacks to allow running read-rtl.c inside RTL frontend (which then fails)

FIXME: enough hacks to read the first note insn in the test

FIXME: handle INSN_UID, flags, and extra text for 'r'

FIXME: handle 'w'

FIXME: enough to parse first insn

FIXME: handle EXPR_LIST etc; handle CODE_LABEL

FIXME: insn ref fixup

FIXME: disable the insns we can't handle, for now

FIXME: the test-loop.c source

FIXME: start introducing rtx_reader class

FIXME: move more rtx parsing into rtx_reader

FIXME: use libcpp for location-handling

FIXME: use 'inform' within fatal_with_file_and_line

FIXME: handle insns with NULL basic block

FIXME: error_at rather than error when insn UID not found

FIXME: don't fixup UID 0

FIXME: add operand names to errors

FIXME: initial version of column-handling

FIXME: make read_name return start location

FIXME: make read_name return a range

FIXME: attempt to print source insns

FIXME: include the closing parenthesis

FIXME: more read_char/unread_char into rtx_reader

FIXME: move lineno/colno into rtx_reader

FIXME: move read_md_file into rtx_reader

FIXME: improve location for fatal_with_file_and_line

FIXME: handle note-specific data for NOTE_INSN_BASIC_BLOCK

FIXME: handle insns that don't have a source location

FIXME: consolidate fixup handling

FIXME: create function and cfg; reconstruct XBBDEF within each insn

FIXME: set up BB_HEAD and BB_END

FIXME: attempt to roundtrip the RTL

FIXME: fix the NOTE_BASIC_BLOCK of NOTE_INSN_BASIC_BLOCK

FIXME: minor tweak to add_fixup_bb

FIXME: reduce debug spew

FIXME: use deferred locations to implement fixup of INSN_LOCATION

FIXME: reduce more debug spew

FIXME: handle numeric JUMP_LABEL values

FIXME: parse LABEL_NUSES

FIXME: introduce require_char etc

FIXME: simplify reg parsing

FIXME: set default value for ORIGINAL_REGNO

FIXME: handle <retval> for REG_EXPR

FIXME: populate x_crtl; more typesafety

FIXME: for now, don't require fndecl to have a DECL_INITIAL within instantiate_decls

FIXME: hack to run one pass

FIXME: start consolidating singletons

FIXME: get pass by name within rtl-frontend.c

FIXME: handle MEM_SIZE, MEM_ALIGN, MEM_ADDR_SPACE

FIXME: consolidate singletons; enables pass 'vregs' to work

FIXME: call initialize_rtl (needed to set flags on singletons)

FIXME: set MEM_OFFSET_KNOWN_P and MEM_OFFSET

FIXME: handle MEM_EXPR, in theory, at least

FIXME: automatically fake locals etc

FIXME: dump NULL strings as (nil)

FIXME: WIP on DejaGnu support

FIXME: reduce debug spew

FIXME: tweak code-labels.rtl

FIMXE: add test of switch (with jump_table_data)

FIXME: add notes.rst

FIXME: start adding tests of error-handling

FIXME: handle return/simple_return values for JUMP_LABEL

FIXME: tests of 'include'

FIXME: roundtrip.exp: delete output file

FIXME: move read_md_filename into rtx_reader

FIXME: make rtx_reader instance survive init_rtx_reader_args[_cb]

FIXME: move in_fname into rtx_reader and rename to m_toplevel_fname

FIXME: missing part of FIXME: make rtx_reader instance survive init_rtx_reader_args[_cb]

FIXME: move first_dir_md_include and last_dir_md_include_ptr into rtx_reader; eliminate max_include_len

FIXME: move base_dir into rtx_reader

FIXME: update linemaps in include handling

FIXME: fixes to include tests

FIXME: fix output from fatal_with_file_and_line

FIXME: add -fsingle-pass= option

FIXME: rename test case

FIXME: move flag parsing into its own function

FIXME: fix creation of basic blocks

FIXME: introduce function_reader::create_cfg

FIXME: break out function_reader ctor

FIXME: more singleton consolidation

FIXME: create edges in CFG

FIXME: more notes.rst

FIXME: add into-cfglayout.rtl

FIXME: add notes about cfgrtl vs cfglayout mode

FIXME: fix typo in vregs.rtl

FIXME: more on into-cfglayout.rtl

FIXME: set last_basic_block_for_fn

FIXME: ensure regno_reg_rtx is populated

FIXME: set up x_cur_insn_uid

FIXME: another blob of merged commits

FIXME: get dfinit.rtl working

FIXME: properly initialize entry and exit blocks

FIXME: move code from pass_expand::execute to rtl_data::init_stack_alignment

FIXME: run df if necessary; ensure reg_obstack is initialized

FIXME: get ira working (requires adding cgraph node)

FIXME: work towards getting reload to work

FIXME: fix parsing of regs with ORIGINAL_REGNO set

FIXME: get pro_and_epilogue working

FIXME: parse INSN_UID *after* mode

FIXME: handle RETURN/SIMPLE_RETURN in for_each_label_ref

FIXME: Get 'final' working
---
 gcc/Makefile.in                                    |   27 +-
 gcc/cfgexpand.c                                    |    7 +-
 gcc/emit-rtl.c                                     |   15 +-
 gcc/emit-rtl.h                                     |    2 +
 gcc/function.c                                     |   41 +-
 gcc/function.h                                     |    2 +-
 gcc/gcc.c                                          |    1 +
 gcc/genattrtab.c                                   |   13 +-
 gcc/genconstants.c                                 |    5 +-
 gcc/genemit.c                                      |   28 +-
 gcc/genenums.c                                     |    5 +-
 gcc/genmddeps.c                                    |    5 +-
 gcc/genoutput.c                                    |    6 +-
 gcc/genpreds.c                                     |    9 +-
 gcc/gensupport.c                                   |   32 +-
 gcc/gensupport.h                                   |    6 +-
 gcc/pass_manager.h                                 |    1 +
 gcc/print-rtl.c                                    |    4 +-
 gcc/read-md.c                                      |  481 ++++++--
 gcc/read-md.h                                      |  155 ++-
 gcc/read-rtl.c                                     |  685 ++++++++++-
 gcc/rtl.c                                          |    2 +
 gcc/rtl.h                                          |    5 +
 gcc/rtl/Make-lang.in                               |  148 +++
 gcc/rtl/TODO.rst                                   |   16 +
 gcc/rtl/config-lang.in                             |   36 +
 gcc/rtl/lang-specs.h                               |   25 +
 gcc/rtl/lang.opt                                   |   36 +
 gcc/rtl/notes.rst                                  |  131 ++
 gcc/rtl/rtl-errors.c                               |   32 +
 gcc/rtl/rtl-frontend.c                             | 1257 ++++++++++++++++++++
 gcc/testsuite/lib/rtl-dg.exp                       |   59 +
 gcc/testsuite/rtl.dg/bad-include.rtl               |    5 +
 gcc/testsuite/rtl.dg/bad-includee.md               |    5 +
 gcc/testsuite/rtl.dg/dfinit.rtl                    |   90 ++
 gcc/testsuite/rtl.dg/final.rtl                     |   51 +
 gcc/testsuite/rtl.dg/good-include.rtl              |    6 +
 gcc/testsuite/rtl.dg/good-includee.md              |    1 +
 gcc/testsuite/rtl.dg/into-cfglayout.rtl            |   85 ++
 gcc/testsuite/rtl.dg/ira.rtl                       |   84 ++
 gcc/testsuite/rtl.dg/missing-include.rtl           |    5 +
 gcc/testsuite/rtl.dg/pro_and_epilogue.rtl          |   38 +
 gcc/testsuite/rtl.dg/roundtrip/code-labels.rtl     |    2 +
 gcc/testsuite/rtl.dg/roundtrip/frame-pointer.rtl   |    4 +
 gcc/testsuite/rtl.dg/roundtrip/insn-with-mode.rtl  |    4 +
 gcc/testsuite/rtl.dg/roundtrip/jump-to-label.rtl   |    6 +
 gcc/testsuite/rtl.dg/roundtrip/jump-to-return.rtl  |    6 +
 .../rtl.dg/roundtrip/jump-to-simple-return.rtl     |    6 +
 .../rtl.dg/roundtrip/note-insn-basic-block.rtl     |    1 +
 .../rtl.dg/roundtrip/note-insn-deleted.rtl         |    1 +
 .../rtl.dg/roundtrip/reg-with-orig-regno.rtl       |    4 +
 gcc/testsuite/rtl.dg/roundtrip/roundtrip.exp       |   82 ++
 .../rtl.dg/roundtrip/test-loop.cleaned.rtl         |   75 ++
 .../rtl.dg/roundtrip/test-switch-after-expand.rtl  |  202 ++++
 gcc/testsuite/rtl.dg/rtl.exp                       |   43 +
 gcc/testsuite/rtl.dg/unknown-insn-uid.rtl          |   11 +
 gcc/testsuite/rtl.dg/unknown-rtx-code.rtl          |    5 +
 gcc/testsuite/rtl.dg/vregs.rtl                     |   80 ++
 gcc/toplev.c                                       |    7 +
 gcc/tree-dfa.c                                     |    5 +
 test-loop.c                                        |   31 +
 61 files changed, 3966 insertions(+), 256 deletions(-)
 create mode 100644 gcc/rtl/Make-lang.in
 create mode 100644 gcc/rtl/TODO.rst
 create mode 100644 gcc/rtl/config-lang.in
 create mode 100644 gcc/rtl/lang-specs.h
 create mode 100644 gcc/rtl/lang.opt
 create mode 100644 gcc/rtl/notes.rst
 create mode 100644 gcc/rtl/rtl-errors.c
 create mode 100644 gcc/rtl/rtl-frontend.c
 create mode 100644 gcc/testsuite/lib/rtl-dg.exp
 create mode 100644 gcc/testsuite/rtl.dg/bad-include.rtl
 create mode 100644 gcc/testsuite/rtl.dg/bad-includee.md
 create mode 100644 gcc/testsuite/rtl.dg/dfinit.rtl
 create mode 100644 gcc/testsuite/rtl.dg/final.rtl
 create mode 100644 gcc/testsuite/rtl.dg/good-include.rtl
 create mode 100644 gcc/testsuite/rtl.dg/good-includee.md
 create mode 100644 gcc/testsuite/rtl.dg/into-cfglayout.rtl
 create mode 100644 gcc/testsuite/rtl.dg/ira.rtl
 create mode 100644 gcc/testsuite/rtl.dg/missing-include.rtl
 create mode 100644 gcc/testsuite/rtl.dg/pro_and_epilogue.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/code-labels.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/frame-pointer.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/insn-with-mode.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/jump-to-label.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/jump-to-return.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/jump-to-simple-return.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/note-insn-basic-block.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/note-insn-deleted.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/reg-with-orig-regno.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/roundtrip.exp
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/test-loop.cleaned.rtl
 create mode 100644 gcc/testsuite/rtl.dg/roundtrip/test-switch-after-expand.rtl
 create mode 100644 gcc/testsuite/rtl.dg/rtl.exp
 create mode 100644 gcc/testsuite/rtl.dg/unknown-insn-uid.rtl
 create mode 100644 gcc/testsuite/rtl.dg/unknown-rtx-code.rtl
 create mode 100644 gcc/testsuite/rtl.dg/vregs.rtl
 create mode 100644 test-loop.c

diff --git a/gcc/cfgexpand.c b/gcc/cfgexpand.c
index 21f21c9..4a62409 100644
--- a/gcc/cfgexpand.c
+++ b/gcc/cfgexpand.c
@@ -6187,10 +6187,7 @@ pass_expand::execute (function *fun)
   discover_nonconstant_array_refs ();
 
   targetm.expand_to_rtl_hook ();
-  crtl->stack_alignment_needed = STACK_BOUNDARY;
-  crtl->max_used_stack_slot_alignment = STACK_BOUNDARY;
-  crtl->stack_alignment_estimated = 0;
-  crtl->preferred_stack_boundary = STACK_BOUNDARY;
+  crtl->init_stack_alignment ();
   fun->cfg->max_jumptable_ents = 0;
 
   /* Resovle the function section.  Some targets, like ARM EABI rely on knowledge
@@ -6222,7 +6219,7 @@ pass_expand::execute (function *fun)
     }
 
   /* Set up parameters and prepare for return, for the function.  */
-  expand_function_start (current_function_decl);
+  expand_function_start (current_function_decl, true);
 
   /* If we emitted any instructions for setting up the variables,
      emit them before the FUNCTION_START note.  */
diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 4e5ba41..6a45376 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -5677,7 +5677,8 @@ init_emit (void)
   crtl->emit.regno_pointer_align
     = XCNEWVEC (unsigned char, crtl->emit.regno_pointer_align_length);
 
-  regno_reg_rtx = ggc_vec_alloc<rtx> (crtl->emit.regno_pointer_align_length);
+  regno_reg_rtx =
+    ggc_cleared_vec_alloc<rtx> (crtl->emit.regno_pointer_align_length);
 
   /* Put copies of all the hard registers into regno_reg_rtx.  */
   memcpy (regno_reg_rtx,
@@ -6295,5 +6296,17 @@ need_atomic_barrier_p (enum memmodel model, bool pre)
       gcc_unreachable ();
     }
 }
+
+/* FIXME.  */
+
+void
+rtl_data::init_stack_alignment ()
+{
+  stack_alignment_needed = STACK_BOUNDARY;
+  max_used_stack_slot_alignment = STACK_BOUNDARY;
+  stack_alignment_estimated = 0;
+  preferred_stack_boundary = STACK_BOUNDARY;
+}
+
 
 #include "gt-emit-rtl.h"
diff --git a/gcc/emit-rtl.h b/gcc/emit-rtl.h
index 39dfce9..80cb50d 100644
--- a/gcc/emit-rtl.h
+++ b/gcc/emit-rtl.h
@@ -55,6 +55,8 @@ struct GTY(()) incoming_args {
 
 /* Datastructures maintained for currently processed function in RTL form.  */
 struct GTY(()) rtl_data {
+  void init_stack_alignment ();
+
   struct expr_status expr;
   struct emit_status emit;
   struct varasm_status varasm;
diff --git a/gcc/function.c b/gcc/function.c
index 43a80b4..f856f87 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -1903,7 +1903,8 @@ instantiate_decls (tree fndecl)
     instantiate_decl_rtl (DECL_RTL (DECL_VALUE_EXPR (decl)));
 
   /* Now process all variables defined in the function or its subblocks.  */
-  instantiate_decls_1 (DECL_INITIAL (fndecl));
+  if (DECL_INITIAL (fndecl))
+    instantiate_decls_1 (DECL_INITIAL (fndecl));
 
   FOR_EACH_LOCAL_DECL (cfun, ix, decl)
     if (DECL_RTL_SET_P (decl))
@@ -5082,10 +5083,12 @@ stack_protect_epilogue (void)
    emitting RTL.
    SUBR is the FUNCTION_DECL node.
    PARMS_HAVE_CLEANUPS is nonzero if there are cleanups associated with
-   the function's parameters, which must be run at any return statement.  */
+   the function's parameters, which must be run at any return statement.
+   EMIT_INSNS is true if instructions are to emitted, false to avoid this
+   (for use by the RTL frontend).  */
 
 void
-expand_function_start (tree subr)
+expand_function_start (tree subr, bool emit_insns)
 {
   /* Make sure volatile mem refs aren't considered
      valid operands of arithmetic insns.  */
@@ -5101,7 +5104,8 @@ expand_function_start (tree subr)
   /* Make the label for return statements to jump to.  Do not special
      case machines with special return instructions -- they will be
      handled later during jump, ifcvt, or epilogue creation.  */
-  return_label = gen_label_rtx ();
+  if (emit_insns)
+    return_label = gen_label_rtx ();
 
   /* Initialize rtx used to return the value.  */
   /* Do this before assign_parms so that we copy the struct value address
@@ -5127,7 +5131,7 @@ expand_function_start (tree subr)
 	  /* Expect to be passed the address of a place to store the value.
 	     If it is passed as an argument, assign_parms will take care of
 	     it.  */
-	  if (sv)
+	  if (sv && emit_insns)
 	    {
 	      value_address = gen_reg_rtx (Pmode);
 	      emit_move_insn (value_address, sv);
@@ -5204,7 +5208,7 @@ expand_function_start (tree subr)
   assign_parms (subr);
 
   /* If function gets a static chain arg, store it.  */
-  if (cfun->static_chain_decl)
+  if (cfun->static_chain_decl && emit_insns)
     {
       tree parm = cfun->static_chain_decl;
       rtx local, chain;
@@ -5248,7 +5252,7 @@ expand_function_start (tree subr)
 
   /* If the function receives a non-local goto, then store the
      bits we need to restore the frame pointer.  */
-  if (cfun->nonlocal_goto_save_area)
+  if (cfun->nonlocal_goto_save_area && emit_insns)
     {
       tree t_save;
       rtx r_save;
@@ -5271,22 +5275,25 @@ expand_function_start (tree subr)
      The move is supposed to make sdb output more accurate.  */
   /* Indicate the beginning of the function body,
      as opposed to parm setup.  */
-  emit_note (NOTE_INSN_FUNCTION_BEG);
+  if (emit_insns)
+    {
+      emit_note (NOTE_INSN_FUNCTION_BEG);
 
-  gcc_assert (NOTE_P (get_last_insn ()));
+      gcc_assert (NOTE_P (get_last_insn ()));
 
-  parm_birth_insn = get_last_insn ();
+      parm_birth_insn = get_last_insn ();
 
-  if (crtl->profile)
-    {
+      if (crtl->profile)
+	{
 #ifdef PROFILE_HOOK
-      PROFILE_HOOK (current_function_funcdef_no);
+	  PROFILE_HOOK (current_function_funcdef_no);
 #endif
-    }
+	}
 
-  /* If we are doing generic stack checking, the probe should go here.  */
-  if (flag_stack_check == GENERIC_STACK_CHECK)
-    stack_check_probe_note = emit_note (NOTE_INSN_DELETED);
+      /* If we are doing generic stack checking, the probe should go here.  */
+      if (flag_stack_check == GENERIC_STACK_CHECK)
+	stack_check_probe_note = emit_note (NOTE_INSN_DELETED);
+    }
 }
 
 void
diff --git a/gcc/function.h b/gcc/function.h
index 501ef68..5272cbb 100644
--- a/gcc/function.h
+++ b/gcc/function.h
@@ -619,7 +619,7 @@ extern void pop_dummy_function (void);
 extern void init_dummy_function_start (void);
 extern void init_function_start (tree);
 extern void stack_protect_epilogue (void);
-extern void expand_function_start (tree);
+extern void expand_function_start (tree, bool);
 extern void expand_dummy_function_end (void);
 
 extern void thread_prologue_and_epilogue_insns (void);
diff --git a/gcc/gcc.c b/gcc/gcc.c
index 1af5920..86cc32b 100644
--- a/gcc/gcc.c
+++ b/gcc/gcc.c
@@ -1287,6 +1287,7 @@ static const struct compiler default_compilers[] =
   {".java", "#Java", 0, 0, 0}, {".class", "#Java", 0, 0, 0},
   {".zip", "#Java", 0, 0, 0}, {".jar", "#Java", 0, 0, 0},
   {".go", "#Go", 0, 1, 0},
+  {".rtl", "#RTL", 0, 1, 0},
   /* Next come the entries for C.  */
   {".c", "@c", 0, 0, 1},
   {"@c",
diff --git a/gcc/genattrtab.c b/gcc/genattrtab.c
index 91d04d4..7bed462 100644
--- a/gcc/genattrtab.c
+++ b/gcc/genattrtab.c
@@ -4235,9 +4235,12 @@ write_insn_cases (FILE *outf, struct insn_ent *ie, int indent)
       {
 	write_indent (outf, indent);
 	if (GET_CODE (ie->def->def) == DEFINE_PEEPHOLE)
-	  fprintf (outf, "case %d:  /* define_peephole, %s:%d */\n",
-		   ie->def->insn_code, ie->def->loc.filename,
-		   ie->def->loc.lineno);
+	  {
+	    expanded_location xloc
+	      = linemap_client_expand_location_to_spelling_point (ie->def->loc);
+	    fprintf (outf, "case %d:  /* define_peephole, %s:%d */\n",
+		     ie->def->insn_code, xloc.file, xloc.line);
+	  }
 	else
 	  fprintf (outf, "case %d:  /* %s */\n",
 		   ie->def->insn_code, XSTR (ie->def->def, 0));
@@ -4638,7 +4641,7 @@ make_internal_attr (const char *name, rtx value, int special)
   attr->is_numeric = 1;
   attr->is_const = 0;
   attr->is_special = (special & ATTR_SPECIAL) != 0;
-  attr->default_val = get_attr_value (file_location ("<internal>", 0),
+  attr->default_val = get_attr_value (GENERATOR_BUILTINS_LOCATION,
 				      value, attr, -2);
 }
 
@@ -5260,7 +5263,7 @@ main (int argc, const char **argv)
       md_rtx_info info;
       info.def = rtx_alloc (DEFINE_ASM_ATTRIBUTES);
       XVEC (info.def, 0) = rtvec_alloc (0);
-      info.loc = file_location ("<internal>", 0);
+      info.loc = GENERATOR_BUILTINS_LOCATION;
       info.index = -1;
       gen_insn (&info);
     }
diff --git a/gcc/genconstants.c b/gcc/genconstants.c
index c10e3e3..c785d31 100644
--- a/gcc/genconstants.c
+++ b/gcc/genconstants.c
@@ -79,7 +79,10 @@ main (int argc, const char **argv)
 {
   progname = "genconstants";
 
-  if (!read_md_files (argc, argv, NULL, NULL))
+  line_maps line_table;
+  generator_linemap_init (&line_table);
+  noop_reader reader (&line_table);
+  if (!reader.read_md_files (argc, argv, NULL))
     return (FATAL_EXIT_CODE);
 
   /* Initializing the MD reader has the side effect of loading up
diff --git a/gcc/genemit.c b/gcc/genemit.c
index 33040aa..d28e2e2 100644
--- a/gcc/genemit.c
+++ b/gcc/genemit.c
@@ -397,7 +397,9 @@ gen_insn (md_rtx_info *info)
   if (XSTR (insn, 0)[0] == 0 || XSTR (insn, 0)[0] == '*')
     return;
 
-  printf ("/* %s:%d */\n", info->loc.filename, info->loc.lineno);
+  expanded_location xloc
+    = linemap_client_expand_location_to_spelling_point (info->loc);
+  printf ("/* %s:%d */\n", xloc.file, xloc.line);
 
   /* Find out how many operands this function has.  */
   get_pattern_stats (&stats, XVEC (insn, 1));
@@ -808,18 +810,30 @@ from the machine description file `md'.  */\n\n");
 	break;
 
       case DEFINE_EXPAND:
-	printf ("/* %s:%d */\n", info.loc.filename, info.loc.lineno);
-	gen_expand (&info);
+	{
+	  expanded_location xloc
+	    = linemap_client_expand_location_to_spelling_point (info.loc);
+	  printf ("/* %s:%d */\n", xloc.file, xloc.line);
+	  gen_expand (&info);
+	}
 	break;
 
       case DEFINE_SPLIT:
-	printf ("/* %s:%d */\n", info.loc.filename, info.loc.lineno);
-	gen_split (&info);
+	{
+	  expanded_location xloc
+	    = linemap_client_expand_location_to_spelling_point (info.loc);
+	  printf ("/* %s:%d */\n", xloc.file, xloc.line);
+	  gen_split (&info);
+	}
 	break;
 
       case DEFINE_PEEPHOLE2:
-	printf ("/* %s:%d */\n", info.loc.filename, info.loc.lineno);
-	gen_split (&info);
+	{
+	  expanded_location xloc
+	    = linemap_client_expand_location_to_spelling_point (info.loc);
+	  printf ("/* %s:%d */\n", xloc.file, xloc.line);
+	  gen_split (&info);
+	}
 	break;
 
       default:
diff --git a/gcc/genenums.c b/gcc/genenums.c
index db46a67..22f8110 100644
--- a/gcc/genenums.c
+++ b/gcc/genenums.c
@@ -49,7 +49,10 @@ main (int argc, const char **argv)
 {
   progname = "genenums";
 
-  if (!read_md_files (argc, argv, NULL, NULL))
+  line_maps line_table;
+  generator_linemap_init (&line_table);
+  noop_reader reader (&line_table);
+  if (!reader.read_md_files (argc, argv, NULL))
     return (FATAL_EXIT_CODE);
 
   puts ("/* Generated automatically by the program `genenums'");
diff --git a/gcc/genmddeps.c b/gcc/genmddeps.c
index fd26a33..9b5eafc 100644
--- a/gcc/genmddeps.c
+++ b/gcc/genmddeps.c
@@ -47,7 +47,10 @@ main (int argc, const char **argv)
   progname = "genmddeps";
   include_callback = add_filedep;
 
-  if (!read_md_files (argc, argv, NULL, NULL))
+  line_maps line_table;
+  generator_linemap_init (&line_table);
+  noop_reader reader (&line_table);
+  if (!reader.read_md_files (argc, argv, NULL))
     return FATAL_EXIT_CODE;
 
   *last = NULL;
diff --git a/gcc/genoutput.c b/gcc/genoutput.c
index f8c25ac..3241115 100644
--- a/gcc/genoutput.c
+++ b/gcc/genoutput.c
@@ -292,7 +292,9 @@ output_insn_data (void)
 
   for (d = idata; d; d = d->next)
     {
-      printf ("  /* %s:%d */\n", d->loc.filename, d->loc.lineno);
+      expanded_location xloc
+	= linemap_client_expand_location_to_spelling_point (d->loc);
+      printf ("  /* %s:%d */\n", xloc.file, xloc.line);
       printf ("  {\n");
 
       if (d->name)
@@ -979,7 +981,7 @@ init_insn_for_nothing (void)
   idata = XCNEW (struct data);
   new (idata) data ();
   idata->name = "*placeholder_for_nothing";
-  idata->loc = file_location ("<internal>", 0);
+  idata->loc = GENERATOR_BUILTINS_LOCATION;
   idata_end = &idata->next;
 }
 
diff --git a/gcc/genpreds.c b/gcc/genpreds.c
index dd7dbbf..ac03103 100644
--- a/gcc/genpreds.c
+++ b/gcc/genpreds.c
@@ -1204,7 +1204,8 @@ write_tm_constrs_h (void)
 
   printf ("\
 /* Generated automatically by the program '%s'\n\
-   from the machine description file '%s'.  */\n\n", progname, in_fname);
+   from the machine description file '%s'.  */\n\n", progname,
+	  rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #ifndef GCC_TM_CONSTRS_H\n\
@@ -1403,7 +1404,8 @@ write_tm_preds_h (void)
 
   printf ("\
 /* Generated automatically by the program '%s'\n\
-   from the machine description file '%s'.  */\n\n", progname, in_fname);
+   from the machine description file '%s'.  */\n\n", progname,
+	  rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #ifndef GCC_TM_PREDS_H\n\
@@ -1552,7 +1554,8 @@ write_insn_preds_c (void)
 
   printf ("\
 /* Generated automatically by the program '%s'\n\
-   from the machine description file '%s'.  */\n\n", progname, in_fname);
+   from the machine description file '%s'.  */\n\n", progname,
+	  rtx_reader_ptr->get_top_level_filename ());
 
   puts ("\
 #include \"config.h\"\n\
diff --git a/gcc/gensupport.c b/gcc/gensupport.c
index 0eb4591..c60364b 100644
--- a/gcc/gensupport.c
+++ b/gcc/gensupport.c
@@ -446,7 +446,7 @@ add_define_attr (const char *name)
   XEXP (t1, 2) = rtx_alloc (CONST_STRING);
   XSTR (XEXP (t1, 2), 0) = "yes";
   e->data = t1;
-  e->loc = file_location ("built-in", -1);
+  e->loc = GENERATOR_BUILTINS_LOCATION;
   e->next = define_attr_queue;
   define_attr_queue = e;
 
@@ -2226,10 +2226,17 @@ process_define_subst (void)
     }
 }
 
-/* A read_md_files callback for reading an rtx.  */
+/* FIXME.  */
 
-static void
-rtx_handle_directive (file_location loc, const char *rtx_name)
+class gen_reader : public rtx_reader
+{
+ public:
+  gen_reader (line_maps *line_table) : rtx_reader (line_table) {}
+  void handle_unknown_directive (file_location, const char *);
+};
+
+void
+gen_reader::handle_unknown_directive (file_location loc, const char *rtx_name)
 {
   auto_vec<rtx, 32> subrtxs;
   if (!read_rtx (rtx_name, &subrtxs))
@@ -2500,7 +2507,7 @@ check_define_attr_duplicates ()
 
 /* The entry point for initializing the reader.  */
 
-bool
+rtx_reader *
 init_rtx_reader_args_cb (int argc, const char **argv,
 			 bool (*parse_opt) (const char *))
 {
@@ -2516,7 +2523,10 @@ init_rtx_reader_args_cb (int argc, const char **argv,
   split_sequence_num = 1;
   peephole2_sequence_num = 1;
 
-  read_md_files (argc, argv, parse_opt, rtx_handle_directive);
+  line_maps *line_table = XCNEW (struct line_maps);
+  generator_linemap_init (line_table);
+  gen_reader *reader = new gen_reader (line_table);
+  reader->read_md_files (argc, argv, parse_opt);
 
   if (define_attr_queue != NULL)
     check_define_attr_duplicates ();
@@ -2532,12 +2542,18 @@ init_rtx_reader_args_cb (int argc, const char **argv,
   if (define_attr_queue != NULL)
     gen_mnemonic_attr ();
 
-  return !have_error;
+  if (have_error)
+    {
+      delete reader;
+      return NULL;
+    }
+
+  return reader;
 }
 
 /* Programs that don't have their own options can use this entry point
    instead.  */
-bool
+rtx_reader *
 init_rtx_reader_args (int argc, const char **argv)
 {
   return init_rtx_reader_args_cb (argc, argv, 0);
diff --git a/gcc/gensupport.h b/gcc/gensupport.h
index 645512c..618359d 100644
--- a/gcc/gensupport.h
+++ b/gcc/gensupport.h
@@ -125,9 +125,9 @@ struct optab_pattern
 };
 
 extern rtx add_implicit_parallel (rtvec);
-extern bool init_rtx_reader_args_cb (int, const char **,
-				     bool (*)(const char *));
-extern bool init_rtx_reader_args (int, const char **);
+extern rtx_reader *init_rtx_reader_args_cb (int, const char **,
+					    bool (*)(const char *));
+extern rtx_reader *init_rtx_reader_args (int, const char **);
 extern bool read_md_rtx (md_rtx_info *);
 extern unsigned int get_num_insn_codes ();
 
diff --git a/gcc/pass_manager.h b/gcc/pass_manager.h
index 464e25f..89b307a 100644
--- a/gcc/pass_manager.h
+++ b/gcc/pass_manager.h
@@ -105,6 +105,7 @@ private:
   context *m_ctxt;
   hash_map<nofree_string_hash, opt_pass *> *m_name_to_pass_map;
 
+ public:
   /* References to all of the individual passes.
      These fields are generated via macro expansion.
 
diff --git a/gcc/print-rtl.c b/gcc/print-rtl.c
index a905127..a2cb69a 100644
--- a/gcc/print-rtl.c
+++ b/gcc/print-rtl.c
@@ -220,7 +220,7 @@ print_rtx (const_rtx in_rtx)
       string:
 
 	if (str == 0)
-	  fputs (" \"\"", outfile);
+	  fputs (" (nil)", outfile);
 	else
 	  fprintf (outfile, " (\"%s\")", str);
 	sawclose = 1;
@@ -586,6 +586,8 @@ print_rtx (const_rtx in_rtx)
 #ifndef GENERATOR_FILE
 	if (XBBDEF (in_rtx, i))
 	  fprintf (outfile, " %i", XBBDEF (in_rtx, i)->index);
+	else
+	  fprintf (outfile, " (nil)");
 #endif
 	break;
 
